<script lang="ts">
    import { getAddressTHAPI } from "src/apis/get-address-th";
    import { validateMobilePhone } from "src/functions/validate-mobile-phone";
    import { addressTHStore } from "src/store";

    import { afterUpdate, onMount, createEventDispatcher } from "svelte";
    export let divMainCss = "";
    export let inputAllCss =
        "w-full h-full text-right text-gray-900 bg-white border border-transparent";

    export let fullname: string = "";
    export let mobilePhone: string = "";
    export let address: string = "";
    export let subdistrict: string = "";
    export let district: string = "";
    export let province: string = "";
    export let zipcode: string = "";
    export let formValid = false;

    const dispatch = createEventDispatcher();

    let addressFind: string[] = [];

    let subDisTrictSelected = false;

    onMount(async () => {
        // get Address from "API";
        if ($addressTHStore.length <= 0) {
            await getAddressTHAPI();
        }
    });

    const findKeyword = (event: any) => {
        subDisTrictSelected = true;
        if ($addressTHStore?.length) {
            if (event.target.value.length > 2) {
                addressFind = $addressTHStore.filter((listItem: any) =>
                    listItem.includes(`${event.target.value}`.trim())
                );
            } else {
                addressFind = [];
                district = "";
                province = "";
                zipcode = "";
                dispatch("formClear");
            }
        }
    };

    const mapItemSelectToInput = (item: string) => {
        if (item) {
            subdistrict = item.split(",")[0] || "";
            district = item.split(",")[1] || "";
            province = item.split(",")[2] || "";
            zipcode = item.split(",")[3] || "";
            subDisTrictSelected = false;
        }
    };

    const validateZipCode = (evt: any) => {
        const theEvent = evt || window.event;
        let key;
        if (theEvent.type === "paste") {
            key = evt.clipboardData.getData("text/plain");
        } else {
            key = theEvent.keyCode || theEvent.which;
            key = String.fromCharCode(key);
        }
        const regex = /[0-9]|\./;
        if (!regex.test(key)) {
            theEvent.returnValue = false;
            if (theEvent.preventDefault) theEvent.preventDefault();
        }
    };

    afterUpdate(() => {
        formValid = !!(
            fullname &&
            mobilePhone &&
            address &&
            subdistrict &&
            district &&
            province &&
            zipcode &&
            zipcode.length == 5
        );
        if (formValid) {
            dispatch("formValid", {
                fullname: fullname,
                mobilePhone: mobilePhone,
                address: address,
                subdistrict: subdistrict,
                district: district,
                province: province,
                zipcode: zipcode,
            });
        }
    });
</script>

<div class="{divMainCss} text-sm border border-white px-2 rounded-b bg-white">
    {#if $addressTHStore?.length > 0}
        <div class="flex flex-col w-full border-b border-gray-200 ">
            <div class="w-full h-8xl mx-auto text-sm">
                <div class="overflow-hiddend">
                    <div
                        class="px-4 py-3 h-full bg-white border-b border-gray-200 break-words grid grid-cols-2"
                    >
                        <div>ชื่อ</div>
                        <div>
                            <input
                                id="i_fullname"
                                bind:value={fullname}
                                type="text"
                                placeholder="ชื่อผู้รับ"
                                class={inputAllCss}
                            />
                        </div>
                    </div>
                </div>
            </div>
            <div class="w-full h-8xl mx-auto text-sm">
                <div class="overflow-hiddend">
                    <div
                        class="px-4 py-3 h-full bg-white border-b border-gray-200 break-words grid grid-cols-2"
                    >
                        <div>เบอร์โทร</div>
                        <div>
                            <input
                                id="i_mobilePhone"
                                maxlength="10"
                                bind:value={mobilePhone}
                                on:keypress={validateMobilePhone}
                                type="tel"
                                placeholder="เบอร์โทรผู้รับ"
                                class={inputAllCss}
                            />
                        </div>
                    </div>
                </div>
            </div>
            <div class="w-full h-8xl mx-auto text-sm">
                <div class="overflow-hiddend">
                    <div
                        class="px-4 py-3 h-full bg-white border-b border-gray-200 break-words grid grid-cols-2"
                    >
                        <div>ตำบล</div>
                        <div>
                            <input
                                id="i_subdistrict"
                                bind:value={subdistrict}
                                on:input={(ev) => findKeyword(ev)}
                                type="text"
                                placeholder="ตำบล"
                                class={inputAllCss}
                            />
                        </div>
                    </div>
                </div>
            </div>

            <div
                class:hidden={!(addressFind && addressFind.length) ||
                    !subDisTrictSelected}
                class:w-full={addressFind && addressFind.length}
                class="px-2 py-2 bg-gray-200"
            >
                {#each addressFind as addr, i}
                    <p
                        on:click={() => {
                            mapItemSelectToInput(addr);
                        }}
                        id={addr}
                        class="hover:bg-gray-300 cursor-pointer p-2"
                    >
                        {addr}
                    </p>
                {/each}
            </div>

            <div class="w-full h-8xl mx-auto text-sm">
                <div class="overflow-hiddend">
                    <div
                        class="px-4 py-3 h-full bg-white border-b border-gray-200 break-words grid grid-cols-2"
                    >
                        <div>อำเภอ</div>
                        <div>
                            <input
                                id="i_district"
                                disabled={!subdistrict}
                                bind:value={district}
                                type="text"
                                placeholder="อำเภอ"
                                class={inputAllCss}
                            />
                        </div>
                    </div>
                </div>
            </div>

            <div class="w-full h-8xl mx-auto text-sm">
                <div class="overflow-hiddend">
                    <div
                        class="px-4 py-3 h-full bg-white border-b border-gray-200 break-words grid grid-cols-2"
                    >
                        <div>จังหวัด</div>
                        <div>
                            <input
                                id="i_province"
                                disabled={!subdistrict}
                                bind:value={province}
                                type="text"
                                placeholder="จังหวัด"
                                class={inputAllCss}
                            />
                        </div>
                    </div>
                </div>
            </div>

            <div class="w-full h-8xl mx-auto text-sm">
                <div class="overflow-hiddend">
                    <div
                        class="px-4 py-3 h-full bg-white border-b border-gray-200 break-words grid grid-cols-2"
                    >
                        <div>รหัสไปรษณีย์</div>
                        <div>
                            <input
                                id="i_zipcode"
                                disabled={!subdistrict}
                                bind:value={zipcode}
                                on:keypress={validateZipCode}
                                type="tel"
                                maxlength="5"
                                placeholder="รหัสไปรษณีย์"
                                class={inputAllCss}
                            />
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="w-full h-8xl mx-auto text-sm">
            <div class="overflow-hiddend">
                <div class="px-4 py-2 bg-white uppercase">
                    <div class="text-left my-auto">
                        <p>ที่อยู่โดยละเอียด</p>
                        <p class="text-xs text-gray-400">
                            หมายเลขห้อง, บ้านเลขที่, ตึก, ชื่อถนน
                        </p>
                    </div>
                </div>
                <div
                    class="px-4 py-2 h-full bg-white border-gray-200 break-words"
                >
                    <div>
                        <textarea
                            class="w-full h-full text-left break-words text-gray-900 bg-white border-b border-gray-200 p-3"
                            id="i_address"
                            name="i_address"
                            type="text"
                            required
                            placeholder="ใส่รายละเอียดที่อยู่"
                            bind:value={address}
                            aria-label="address"
                        />
                    </div>
                </div>
            </div>
        </div>
    {:else}
        <div class="flex justify-center">
            <p class="py-1">กำลังโหลดข้อมูลที่อยู่...</p>
        </div>
    {/if}
</div>
